using System;
using TSLab.DataSource;

namespace FinInfoCache.Common
{
    public class FinInfoBlock
    {
        /// <summary>
        ///  ( UTC)  
        /// </summary>
        public DateTime LastUpdate { get; set; }
        /// <summary>
        ///  
        /// </summary>
        public double Ask { get; set; }
        /// <summary>
        ///  
        /// </summary>
        public double Bid { get; set; }
        /// <summary>
        ///        
        /// </summary>
        public double BuyCount { get; set; }
        /// <summary>
        ///         ,     
        /// </summary>
        public double BuySqty { get; set; }
        /// <summary>
        ///        
        /// </summary>
        public double SellCount { get; set; }
        /// <summary>
        ///         ,     
        /// </summary>
        public double SellSqty { get; set; }
        /// <summary>
        ///  ()  
        /// </summary>
        public double TheoriticPrice { get; set; }
        /// <summary>
        ///   , %
        /// </summary>
        public double Volatility { get; set; }
        /// <summary>
        ///  .
        /// </summary>
        public double OpenInterest { get; set; }

        /// <summary>
        ///     <see cref="FinInfo"/>  LastUpdate c   <see cref="FinInfoBlock"/>
        /// </summary>
        /// <param name="fi"></param>
        /// <returns></returns>
        public bool EqualsExceptLastUpdate(FinInfo fi)
        {
            return Ask == (fi.Ask ?? 0) &&
                   Bid == (fi.Bid ?? 0) &&
                   BuyCount == (fi.BuyCount ?? 0) &&
                   BuySqty == (fi.BuySqty ?? 0) &&
                   SellCount == (fi.SellCount ?? 0) &&
                   SellSqty == (fi.SellSqty ?? 0) &&
                   TheoriticPrice == (fi.TheoriticPrice ?? 0) &&
                   Volatility == (fi.Volatility ?? 0) &&
                   OpenInterest == (fi.OpenInterest ?? 0);
        }
    }
}