using System.Collections.Generic;
using FinInfoCache.Common;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace FinInfoCache.Handlers
{
    /// <summary>
    ///          
    ///  =  / 
    /// </summary>
    [HandlerCategory(Consts.Category)]
    [HandlerName("")]
    public class FininfoReaderAvgSell : IBar2DoubleHandler
    {
        [HandlerParameter(true, Consts.DefPath, Name = Consts.PathName, NotOptimized = true)]
        public string DataPath { get; set; }

        public IList<double> Execute(ISecurity security)
        {
            var fi = FininfoCache.GetFininfo(security, DataPath);
            int count = fi.Count;
            var values = new double[count];
            for (int i = 0; i < count; i++)
            {
                var f = fi[i];
                values[i] = f.SellCount != 0 ? f.SellSqty / f.SellCount : 0;
            }
            return values;
        }
    }
}