using System;
using System.Collections.Generic;
using FinInfoCache.Common;
using TSLab.Script;
using TSLab.Script.Handlers;

namespace FinInfoCache.Handlers
{
    /// <summary>
    ///             ,     
    ///   ,     ,     
    /// </summary>
    [HandlerCategory(Consts.Category)]
    [HandlerName("")]
    public class FininfoReaderDeltaSqtyMoment : IBar2DoubleHandler
    {
        [HandlerParameter(true, Consts.DefPath, Name = Consts.PathName, NotOptimized = true)]
        public string DataPath { get; set; }

        [HandlerParameter(true, "1", Min = "1", Max = "10", Name = "")]
        public int Period { get; set; }

        public IList<double> Execute(ISecurity security)
        {
            var fi = FininfoCache.GetFininfo(security, DataPath);
            int count = fi.Count;
            var values = new double[count];
            int p = Period;
            for (int i = Math.Max(0, p); i < count; i++)
            {
                var f = fi[i];
                var fl = fi[i - p];
                values[i] = (f.BuySqty - f.SellSqty) - (fl.BuySqty - fl.SellSqty);
            }
            return values;
        }
    }
}